---
title: '::part()'
slug: 'Web/CSS/::part'
tags:
  - '::part'
  - CSS
  - Draft
  - Experimental
  - NeedsBrowserCompatibility
  - NeedsExample
  - Pseudo-element
  - Reference
  - Selector
---
<div>{{CSSRef}}</div>

<p>The <strong><code>::part</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/Pseudo-elements">pseudo-element</a> represents any element within a <a href="/en-US/docs/Web/Web_Components/Using_shadow_DOM">shadow tree</a> that has a matching {{HTMLAttrxRef("part")}} attribute.</p>

<pre class="brush: css no-line-numbers notranslate">custom-element::part(foo) {
  /* Styles to apply to the `foo` part */
}
</pre>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">{{CSSSyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;template id="tabbed-custom-element"&gt;
&lt;style type="text/css"&gt;
*, ::before, ::after {
  box-sizing: border-box;
  padding: 1rem;
}
:host {
  display: flex;
}
&lt;/style&gt;
&lt;div part="tab active"&gt;Tab 1&lt;/div&gt;
&lt;div part="tab"&gt;Tab 2&lt;/div&gt;
&lt;div part="tab"&gt;Tab 3&lt;/div&gt;
&lt;/template&gt;

&lt;tabbed-custom-element&gt;&lt;/tabbed-custom-element&gt;</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css notranslate">tabbed-custom-element::part(tab) {
  color: #0c0dcc;
  border-bottom: transparent solid 2px;
}

tabbed-custom-element::part(tab):hover {
  background-color: #0c0d19;
  border-color: #0c0d33;
}

tabbed-custom-element::part(tab):hover:active {
  background-color: #0c0d33;
}

tabbed-custom-element::part(tab):focus {
  box-shadow:
    0 0 0 1px #0a84ff inset,
    0 0 0 1px #0a84ff,
    0 0 0 4px rgba(10, 132, 255, 0.3);
}

tabbed-custom-element::part(active) {
  color: #0060df;
  border-color: #0a84ff !important;
}
</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js notranslate">let template = document.querySelector("#tabbed-custom-element");
globalThis.customElements.define(template.id, class extends HTMLElement {
  constructor() {
    super();
    this.attachShadow({ mode: "open" });
    this.shadowRoot.appendChild(template.content);
  }
});
</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample('Examples')}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName("CSS Shadow Parts", "#part", "::part")}}</td>
			<td>{{Spec2("CSS Shadow Parts")}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.selectors.part")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>The {{HTMLAttrxRef("part")}} attribute - Used to define parts which can be selected by the <code>::part()</code> selector</li>
	<li>The {{HTMLAttrxRef("exportparts")}} attribute - Used to transitively export shadow parts from a nested shadow tree into a containing light tree.</li>
	<li><a href="https://github.com/fergald/docs/blob/master/explainers/css-shadow-parts-1.md">Explainer: CSS Shadow ::part and ::theme</a></li>
</ul>
